## numatop 1.0.3

=== Makefile ===
PREFIXDIR = /usr/local
BINDIR = /bin
MANDIR = /usr/share/man/man8
PROG = numatop
CC = gcc
LD = gcc
CFLAGS = -g -Wall -O2
LDFLAGS = -g
LDLIBS = -lncurses -lpthread -lnuma

COMMON_OBJS = cmd.o disp.o lwp.o numatop.o page.o perf.o \
	proc.o reg.o util.o win.o

OS_OBJS = os_cmd.o os_perf.o os_win.o node.o map.o \
	os_util.o plat.o pfwrapper.o sym.o os_page.o

INTEL_OBJS = wsm.o snb.o nhm.o

all: $(PROG)

$(PROG): $(COMMON_OBJS) $(OS_OBJS) $(INTEL_OBJS)
	$(LD) $(LDFLAGS) -o $@ $(COMMON_OBJS) $(OS_OBJS) $(INTEL_OBJS) $(LDLIBS)

%.o: ./common/%.c ./common/include/*.h ./common/include/os/*.h
	$(CC) $(CFLAGS) -o $@ -c $<

%.o: ./common/os/%.c ./common/include/*.h ./common/include/os/*.h
	$(CC) $(CFLAGS) -o $@ -c $<

%.o: ./intel/%.c ./intel/include/*.h
	$(CC) $(CFLAGS) -o $@ -c $<

install: $(PROG)
	install -m 0755 $(PROG) $(PREFIXDIR)$(BINDIR)/
	gzip -c numatop.8 > numatop.8.gz
	mv -f numatop.8.gz $(MANDIR)/

clean:
	rm -rf *.o $(PROG)

=== debian/changelog ===
numatop (1.0.3-0ubuntu1) wily; urgency=low

  * Initial release (LP: #1495439)
  * Fix sign comparison issue comparing g_run_secs and diff_ms
  * Add sanity checking to reg_init() errors
  * remove null pointer check on nrec, it is always non-NULL
  * Initialize naccess_total to zero
  * common/os: pfwrapper: make loop index a uint64_t type
  * common/os: map: tidy up gcc warning, make i an unsigned int
  * Only process pipe read if read was successful
  * tty colors are broken without using use_default_colors()
  * mgen: calibrate_cpuinfo: ensure we do not overflow buffer unit
  * calibrate_cpuinfo: ensure we do not overflow buffer unit
  * Sync with upstream 1.0.3
  * Apply fixes since 1.0.3

 -- Colin King <colin.king@ubuntu.com>  Mon, 14 Sep 2015 10:10:00 +0100

numatop (1.0.2-1) unstable; urgency=low

  * Initial packaging

 -- Colin King <colin.king@ubuntu.com>  Mon, 24 Mar 2014 12:05:23 +0000

=== debian/control ===
Source: numatop
Section: admin
Priority: optional
Maintainer: Colin King <colin.king@ubuntu.com>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9), libnuma-dev, libncurses-dev
Homepage: https://01.org/numatop

Package: numatop
Architecture: linux-i386 linux-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NUMA runtime observation tool
 NumaTOP is an observation tool for runtime memory locality characterization
 and analysis of processes and threads running on a NUMA system. It helps the
 user characterize the NUMA behavior of processes and threads and identify
 where the NUMA-related performance bottlenecks reside.

## numatop 1.0.4

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 OS_OBJS = os_cmd.o os_perf.o os_win.o node.o map.o \
 	os_util.o plat.o pfwrapper.o sym.o os_page.o
 
-INTEL_OBJS = wsm.o snb.o nhm.o
+INTEL_OBJS = wsm.o snb.o nhm.o bdw.o
 
 all: $(PROG)

=== test/mgen/Makefile ===
PROG = mgen
CC = gcc
LD = gcc
CFLAGS = -g -Wall
LDLIBS = -lpthread

OBJS = mgen.o

all: $(PROG)

$(PROG): $(OBJS)
	$(LD) $(LDLIBS) -o $@ $(OBJS)

%.o: %.c
	$(CC) $(CFLAGS) -o $@ -c $<

clean:
	rm -rf *.o mgen

=== debian/changelog ===
numatop (1.0.4-8) unstable; urgency=medium

  [ Jin Yao]
   - Fix crash due to invalid pid returned in perf sample

 -- Colin King <colin.king@canonical.com>  Tue, 24 Oct 2017 17:48:34 +0000

numatop (1.0.4-7) unstable; urgency=medium

  * Update standards version to 4.1.1
  [ Ravi Bangoria ]
    - mgen: Compile without optimization
    - Powerpc: Add support for Power9
    - Add dependency header files in Makefile
    - common/perf: Fix null pointer dereference
  
 -- Colin King <colin.king@canonical.com>  Thu, 19 Oct 2017 10:26:41 +0100

numatop (1.0.4-6) unstable; urgency=medium

  * Enable builds for linux-ppc64el (LP: #1714193)

 -- Colin King <colin.king@canonical.com>  Thu, 31 Aug 2017 09:25:12 +0100

numatop (1.0.4-5) unstable; urgency=medium

  * Sync with current numatop tip for new powerpc functionality
  [ Ravi Bangoria ]
    - Fix realloc size for nproc > PROCFS_ID_NUM
    - Intel: Move intel specific code under intel/
    - Powerpc: Very basic support
    - Powerpc: Add FEATURES file
    - Increase NCPUS_NODE_MAX to 128
    - Powerpc: Fix CPU% utilization for PowerVMs
    - Support multiple perf event for one UI parameter
    - Powerpc: Use pvr for platform detection
    - Fix cpu% utilization when freq calculated by calibrate_by_tsc()
    - Powerpc: Don't show kernel callchain
    - Replace hardcoded 0 with macro PERF_COUNT_CORE_CLK
    - Change syntax of os_calibrate()
    - Change syntax of current_ms()
    - processor_bind()/unbind(): Make them global
    - Make numatop.c free of global vars
    - mgen: Reuse functions instead of redefining them
    - mgen: Move intel specific code under test/intel/ dir
    - mgen: port to powerpc
    - Add 'IBM' along with 'Intel'
   [ Jin Yao ]
    - Port LLC occupancy and Memory bandwidth monitoring features
      to new interface
   [ Colin Ian King ]
    - debian/control: update Standards-Version to 4.0.0
    - move Makefile patch to end of patch series rather than at start
    
 -- Colin King <colin.king@canonical.com>  Tue, 29 Aug 2017 16:21:11 +0100

numatop (1.0.4-4) unstable; urgency=medium

  [ Jin Yao ]
  * New features:
    - Add a feature to show per-Node UPI bandwidth for SKX

  [ Colin Ian King ]
  * Minor fixes:
    - test: mgen: use %u format specifier for unsigned int s_randseed
    - Fix EOF condition from getopt being compared to char type
    
 -- Colin King <colin.king@canonical.com>  Thu, 13 Apr 2017 22:44:23 +0100

numatop (1.0.4-3) unstable; urgency=medium

  [ Jin Yao ]
  * New features:
    - Add SKX support
    - Add a feature to show per-Node memory controller bandwidth
    - Add a feature to show per-Node QPI bandwidth
    - Use libnuma API to create memory on a specified node

  [ Colin Ian King ]
  * Fixes and code clean up
    - Refresh makefile hardening patch
    - Minor build warning fixes
    - Don't compare a double with 0.0
    - Make countval_sum a static function
    - Make llrec_add a static function
    - Make bufdesc_cut a static function
    - Put g_precise, g_ncpus and g_sortkey into numatop.h
    - Put g_scr_height and g_scr_width into reg.h
    - Remove duplicate declaration of dump_ctl
    - Fix some discarded 'const' qualifiers on pointer target type
    - Initialise nprocs to zero to avoid printing garbage nprocs value
    - Do not print garbage latency if lat_data_get fails to get latency
    - common/os: fix null pointer dereference on nrec

 -- Colin King <colin.king@canonical.com>  Fri, 9 Dec 2016 11:51:15 +0000

numatop (1.0.4-2) unstable; urgency=medium

  * debian/control: update Standards-Version to 3.9.8

 -- Colin King <colin.king@canonical.com>  Wed, 5 Oct 2016 20:45:18 +0100

numatop (1.0.4-1) unstable; urgency=medium

  * Sync with upstream 1.0.4 release
  * Remove patches that are now in 1.0.4 release
  * Refresh hardening patch for Makefile

 -- Colin King <colin.king@canonical.com>  Sun, 20 Dec 2015 12:53:00 +0000

numatop (1.0.3-2) unstable; urgency=medium

  * Fix sign comparison issue comparing g_run_secs and diff_ms
  * Add sanity checking to reg_init() errors
  * remove null pointer check on nrec, it is always non-NULL
  * Initialize naccess_total to zero
  * common/os: pfwrapper: make loop index a uint64_t type
  * common/os: map: tidy up gcc warning, make i an unsigned int
  * Only process pipe read if read was successful
  * tty colors are broken without using use_default_colors()
  * mgen: calibrate_cpuinfo: ensure we do not overflow buffer unit
  * calibrate_cpuinfo: ensure we do not overflow buffer unit

 -- Colin King <colin.king@canonical.com>  Mon, 28 Sep 2015 21:57:00 +0100

numatop (1.0.3-1) unstable; urgency=low

  * Upload to Debian (Closes: #705653)
  * Sync with upstream 1.0.3
  * Apply fixes since 1.0.3

 -- Colin King <colin.king@ubuntu.com>  Wed, 26 Aug 2015 09:46:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: numatop
 Section: admin
 Priority: optional
-Maintainer: Colin King <colin.king@ubuntu.com>
-Standards-Version: 3.9.6
+Maintainer: Colin King <colin.king@canonical.com>
+Standards-Version: 4.1.1
 Build-Depends: debhelper (>= 9), libnuma-dev, libncurses-dev
 Homepage: https://01.org/numatop
 
 Package: numatop
-Architecture: linux-i386 linux-amd64
+Architecture: linux-i386 linux-amd64 linux-ppc64el
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: NUMA runtime observation tool
  NumaTOP is an observation tool for runtime memory locality characterization

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); dh_auto_build

override_dh_auto_install:
	mkdir -p $$(pwd)/debian/numatop/usr/bin
	mkdir -p $$(pwd)/debian/numatop/usr/share/man/man8
	$(MAKE) PREFIXDIR=$$(pwd)/debian/numatop/usr \
	MANDIR=$$(pwd)/debian/numatop/usr/share/man/man8 install

=== debian/watch ===
version=3
https://01.org/numatop/downloads \
  .*/numatop_linux_(.+)\.tar.*\.gz

## numatop 2.1

=== debian/changelog ===
numatop (2.1-6) unstable; urgency=low

  * Correct debian maintainer email address.
  * Add Colin Ian King to debian/copyright for Debian files
  * Update watch file to new repo location
  * Update project url to Inte github page
  * Remove whitespace from changelog

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 6 Dec 2021 15:27:28 +0100

numatop (2.1-5) unstable; urgency=low

  * Add patches 0008..0010 to clear up FTBFS issues with new toolchain

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 6 Dec 2021 15:16:17 +0100

numatop (2.1-4) unstable; urgency=low

  * Debian/control: update compat to 13, remove compat file
  * Debian/control: add Rules-Requires-Root

 -- Colin King <colin.king@canonical.com>  Sat, 4 Jul 2020 15:46:21 +0100

numatop (2.1-3) unstable; urgency=low

  * Minor build warning and spelling mistake fixes:
    - Trivial fix to spelling mistakes in source
    - Fix several printf format specifiers
    - Clean up 32 bit build warnings

 -- Colin King <colin.king@canonical.com>  Wed, 26 Feb 2020 15:01:26 +0000

numatop (2.1-2) unstable; urgency=low

  * Pull in upstream fixes: to fix FTBFS issues with newer toolchains,
    fix build support for arches and clean up gcc 8.2 warnings
    - Swap link arg order here
    - configure.ac: add build support for 32 bit i686 (1/2)
    - configure.ac: add build support for 32 bit i686 (2/2)
    - common/os: ensure command buffer is large enough

 -- Colin King <colin.king@canonical.com>  Fri, 24 Aug 2018 09:29:48 +0100

numatop (2.1-1) unstable; urgency=low

  * Re-sync with upstream 2.1 release
  * Allow i686 host builds with configure.ac change

 -- Colin King <colin.king@canonical.com>  Tue, 15 May 2018 11:48:12 +0100

numatop (1.0.4-9) unstable; urgency=medium

  * Fix global-files-wildcard-not-first-paragraph-in-dep5-copyright
  * Fix spelling-error-in-patch-description warnings
  * Update Standards-Version to 4.1.2
  * Update compat to 11
  * Fix global-files-wildcard-not-first-paragraph-in-dep5-copyright
  * Fix file-contains-trailing-whitespace in debian/changelog
  * insecure-copyright-format-uri in debian/copyright

 -- Colin King <colin.king@canonical.com>  Tue, 6 Mar 2018 09:08:11 +0000

=== debian/control ===
Source: numatop
Rules-Requires-Root: no
Section: admin
Priority: optional
Maintainer: Colin Ian King <colin.i.king@gmail.com>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               libnuma-dev,
               libncurses-dev,
               check,
               autoconf,
               automake,
               libtool,
               m4,
               pkg-config
Homepage: https://github.com/intel/numatop

Package: numatop
Architecture: linux-i386 linux-amd64 linux-ppc64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NUMA runtime observation tool
 NumaTOP is an observation tool for runtime memory locality characterization
 and analysis of processes and threads running on a NUMA system. It helps the
 user characterize the NUMA behavior of processes and threads and identify
 where the NUMA-related performance bottlenecks reside.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); dh_auto_build

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?V?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/intel/numatop/tags \
             (?:.*?/)?V?(\d[\d.]*)\.tar\.gz debian uupdate

## numatop 2.3

=== debian/changelog ===
numatop (2.3-3) unstable; urgency=low

  * Add upstream commit to fix warning for systems with many nodes/cpus
    0011-Update-the-error-message.patch

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 13 Jan 2023 15:45:51 +0000

numatop (2.3-2) unstable; urgency=low

  * debian/watch: should be a v in version number and not V
  * debian/control: update standards version to 4.6.1

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 7 Dec 2022 15:39:41 +0000

numatop (2.3-1) unstable; urgency=low

  * Re-sync with upstream 2.3 release
   - remove patches that are now in upstream version

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 28 Oct 2022 22:41:22 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.1.2
+Standards-Version: 4.6.1
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libnuma-dev,

## numatop 2.4

=== debian/changelog ===
numatop (2.4-2) unstable; urgency=low

  * Add missing hardening flags
  * Add in various upstream fixes:
    0021-Fix-remaining-clang-warnings.patch
    0022-x86-zen-Add-Zen-5-and-later-support.patch
    0023-add-required-SECURITY.md-file-for-OSSF-Scorecard-com.patch
    0024-readme-Add-note-on-AMD-support.patch
    0025-numatop-powerpc-Add-Power11-support.patch
    0026-common-reg.c-use-explicit-format-string.patch
    0027-common-Use-sym_type_t-in-elf64_binary_read-signature.patch
    0028-common-Remove-unnecessary-temp-buffer.patch
    0029-common-Use-memcpy-to-the-process-name-to-a-line.patch
    0030-common-Increase-node-string-buffer-size.patch
    0032-common-Replace-malloc-strncpy-with-strdup.patch
    0033-common-Build-node-string-with-bound-checks.patch
    0034-Add-missing-hunks-from-last-change.patch
    0035-common-remove-extra-d-from-debug_print-and-fix-gramm.patch
    0036-common-fix-uninitialized-string-content-in-dyn-pid-0.patch
    0036-common-fix-uninitialized-string-content-in-dyn-pid-0.patch~
    0037-common-Add-missing-t-from-help-and-manual.patch
    0038-common-perform-sanity-check-on-num-to-avoid-array-bo.patch
    0039-common-ensure-the-dump-and-log-files-are-not-opened-.patch
    0040-common-cast-difference-of-data_head-and-data_tail-to.patch
    0041-common-resolve_unique-Fix-uninitialised-return-of-po.patch
    0042-common-fix-timeout-option-break-out-of-loop.patch
    0043-common-use-mount-umount-system-calls-rather-than-usi.patch
    0043-common-use-mount-umount-system-calls-rather-than-usi.patch~
    0044-common-remove-executing-commands-for-directory-and-f.patch

 -- Colin Ian King <colin.i.king@gmail.com>  Tue, 13 Aug 2024 12:16:24 +0100

numatop (2.4-1) unstable; urgency=low

  * Re-sync with upstream 2.4 release
  * debian/control: update standards version to 4.7
  * remove 0011-Update-the-error-message.patch as this is now upstream
  * add 0020-x86-Fix-missing-fields-for-EMR-support.patch to fix FTBFS

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 31 Jul 2024 11:30:11 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libnuma-dev,

## numatop 2.5

=== debian/changelog ===
numatop (2.5-1) unstable; urgency=low

  * Re-sync with upstream 2.4 release
  * remove patches now these are in the 2.4 release
  * replace pkg-config with pkgconf

 -- Colin Ian King <colin.i.king@gmail.com>  Thu, 21 Nov 2024 09:21:23 +0000

## numatop 2.5.1

=== debian/changelog ===
numatop (2.5.1-2) unstable; urgency=low

  * Orphan upload
  * Update Maintainer field to Debian QA Group <packages@qa.debian.org>
    so package can be orphaned
  * Update Standards-Version to 4.7.2
  * Update debian copyright to 2025

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Sep 2025 13:45:42 +0100

numatop (2.5.1-1) unstable; urgency=low

  * Re-sync with upstream 2.5.1 release

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 4 Dec 2024 16:23:51 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Rules-Requires-Root: no
 Section: admin
 Priority: optional
-Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.7.0
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Standards-Version: 4.7.2
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libnuma-dev,
@@ -13,7 +13,7 @@
                automake,
                libtool,
                m4,
-               pkg-config
+               pkgconf
 Homepage: https://github.com/intel/numatop
 
 Package: numatop

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,8 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/intel/numatop/tags \
             (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
